package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.QueryModelMapper;
import com.sa.ibiz.demo.demo.domain.QueryModel;
import com.sa.ibiz.demo.demo.service.QueryModelService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.QueryModelSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.DataEntityService;

/**
 * 实体[QueryModel] 服务对象接口实现
 */
@Service
public class QueryModelServiceImpl extends ServiceImplBase<QueryModelMapper, QueryModel> implements QueryModelService{

    @Autowired
    private DataEntityService deService;

    @Resource
    private QueryModelMapper querymodelMapper;


    @Override
    public boolean create(QueryModel et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(QueryModel et){
        this.beforeUpdate(et);
		this.querymodelMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(QueryModel et){
		return et.getQuerymodelid();  
    }

    @Override
    public boolean getDraft(QueryModel et)  {
    if((!StringUtils.isEmpty(et.getDeid())) && et.getDe() == null){
            try {
                et.setDe(deService.getById(et.getDeid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<QueryModel> listDefault(QueryModelSearchFilter filter) {
		return querymodelMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<QueryModel> searchDefault(QueryModelSearchFilter filter) {
		return querymodelMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}


	public List<QueryModel> listCurDE(QueryModelSearchFilter filter) {
		return querymodelMapper.searchCurDE(filter,filter.getSelectCond());
	}

	public Page<QueryModel> searchCurDE(QueryModelSearchFilter filter) {
		return querymodelMapper.searchCurDE(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return querymodelMapper.selectRow(sql);
    }

 }